git-rebase.shon commit git-merge-recursive: honor merge.conflictstyle once again (e137a89)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest="$GIT_DIR"/rebase-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget to use git add?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        cmt=`cat "$dotest/current"`
  63        if ! git diff-index --quiet --ignore-submodules HEAD --
  64        then
  65                if ! git commit --no-verify -C "$cmt"
  66                then
  67                        echo "Commit failed, please do not call \"git commit\""
  68                        echo "directly, but instead do one of the following: "
  69                        die "$RESOLVEMSG"
  70                fi
  71                printf "Committed: %0${prec}d " $msgnum
  72        else
  73                printf "Already applied: %0${prec}d " $msgnum
  74        fi
  75        git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  76
  77        prev_head=`git rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat "$dotest/cmt.$1")"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git rev-parse --verify HEAD)
  90        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
  91        msgnum=$(cat "$dotest/msgnum")
  92        end=$(cat "$dotest/end")
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                git rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118move_to_original_branch () {
 119        test -z "$head_name" &&
 120                head_name="$(cat "$dotest"/head-name)" &&
 121                onto="$(cat "$dotest"/onto)" &&
 122                orig_head="$(cat "$dotest"/orig-head)"
 123        case "$head_name" in
 124        refs/*)
 125                message="rebase finished: $head_name onto $onto"
 126                git update-ref -m "$message" \
 127                        $head_name $(git rev-parse HEAD) $orig_head &&
 128                git symbolic-ref HEAD $head_name ||
 129                die "Could not move back to $head_name"
 130                ;;
 131        esac
 132}
 133
 134finish_rb_merge () {
 135        move_to_original_branch
 136        rm -r "$dotest"
 137        echo "All done."
 138}
 139
 140is_interactive () {
 141        test -f "$dotest"/interactive ||
 142        while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
 143                shift
 144        done && test -n "$1"
 145}
 146
 147run_pre_rebase_hook () {
 148        if test -x "$GIT_DIR/hooks/pre-rebase"
 149        then
 150                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 151                        echo >&2 "The pre-rebase hook refused to rebase."
 152                        exit 1
 153                }
 154        fi
 155}
 156
 157test -f "$GIT_DIR"/rebase-apply/applying &&
 158        die 'It looks like git-am is in progress. Cannot rebase.'
 159
 160is_interactive "$@" && exec git-rebase--interactive "$@"
 161
 162if test $# -eq 0
 163then
 164        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 165        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 166                die 'A rebase is in progress, try --continue, --skip or --abort.'
 167        die "No arguments given and $GIT_DIR/rebase-apply already exists."
 168fi
 169
 170while test $# != 0
 171do
 172        case "$1" in
 173        --continue)
 174                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 175                        die "No rebase in progress?"
 176
 177                git diff-files --quiet --ignore-submodules || {
 178                        echo "You must edit all merge conflicts and then"
 179                        echo "mark them as resolved using git add"
 180                        exit 1
 181                }
 182                if test -d "$dotest"
 183                then
 184                        prev_head=$(cat "$dotest/prev_head")
 185                        end=$(cat "$dotest/end")
 186                        msgnum=$(cat "$dotest/msgnum")
 187                        onto=$(cat "$dotest/onto")
 188                        continue_merge
 189                        while test "$msgnum" -le "$end"
 190                        do
 191                                call_merge "$msgnum"
 192                                continue_merge
 193                        done
 194                        finish_rb_merge
 195                        exit
 196                fi
 197                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 198                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 199                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 200                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 201                move_to_original_branch
 202                exit
 203                ;;
 204        --skip)
 205                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 206                        die "No rebase in progress?"
 207
 208                git reset --hard HEAD || exit $?
 209                if test -d "$dotest"
 210                then
 211                        git rerere clear
 212                        prev_head=$(cat "$dotest/prev_head")
 213                        end=$(cat "$dotest/end")
 214                        msgnum=$(cat "$dotest/msgnum")
 215                        msgnum=$(($msgnum + 1))
 216                        onto=$(cat "$dotest/onto")
 217                        while test "$msgnum" -le "$end"
 218                        do
 219                                call_merge "$msgnum"
 220                                continue_merge
 221                        done
 222                        finish_rb_merge
 223                        exit
 224                fi
 225                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 226                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 227                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 228                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 229                move_to_original_branch
 230                exit
 231                ;;
 232        --abort)
 233                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 234                        die "No rebase in progress?"
 235
 236                git rerere clear
 237                if test -d "$dotest"
 238                then
 239                        move_to_original_branch
 240                else
 241                        dotest="$GIT_DIR"/rebase-apply
 242                        move_to_original_branch
 243                fi
 244                git reset --hard $(cat "$dotest/orig-head")
 245                rm -r "$dotest"
 246                exit
 247                ;;
 248        --onto)
 249                test 2 -le "$#" || usage
 250                newbase="$2"
 251                shift
 252                ;;
 253        -M|-m|--m|--me|--mer|--merg|--merge)
 254                do_merge=t
 255                ;;
 256        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 257                --strateg=*|--strategy=*|\
 258        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 259                case "$#,$1" in
 260                *,*=*)
 261                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 262                1,*)
 263                        usage ;;
 264                *)
 265                        strategy="$2"
 266                        shift ;;
 267                esac
 268                do_merge=t
 269                ;;
 270        -v|--verbose)
 271                verbose=t
 272                ;;
 273        --whitespace=*)
 274                git_am_opt="$git_am_opt $1"
 275                ;;
 276        -C*)
 277                git_am_opt="$git_am_opt $1"
 278                ;;
 279        -*)
 280                usage
 281                ;;
 282        *)
 283                break
 284                ;;
 285        esac
 286        shift
 287done
 288
 289# Make sure we do not have $GIT_DIR/rebase-apply
 290if test -z "$do_merge"
 291then
 292        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 293        then
 294                rmdir "$GIT_DIR"/rebase-apply
 295        else
 296                echo >&2 '
 297It seems that I cannot create a rebase-apply directory, and
 298I wonder if you are in the middle of patch application or another
 299rebase.  If that is not the case, please
 300        rm -fr '"$GIT_DIR"'/rebase-apply
 301and run me again.  I am stopping in case you still have something
 302valuable there.'
 303                exit 1
 304        fi
 305else
 306        if test -d "$dotest"
 307        then
 308                die "previous rebase directory $dotest still exists." \
 309                        'Try git rebase (--continue | --abort | --skip)'
 310        fi
 311fi
 312
 313# The tree must be really really clean.
 314git update-index --ignore-submodules --refresh || exit
 315diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 316case "$diff" in
 317?*)     echo "cannot rebase: your index is not up-to-date"
 318        echo "$diff"
 319        exit 1
 320        ;;
 321esac
 322
 323# The upstream head must be given.  Make sure it is valid.
 324upstream_name="$1"
 325upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 326    die "invalid upstream $upstream_name"
 327
 328# Make sure the branch to rebase onto is valid.
 329onto_name=${newbase-"$upstream_name"}
 330onto=$(git rev-parse --verify "${onto_name}^0") || exit
 331
 332# If a hook exists, give it a chance to interrupt
 333run_pre_rebase_hook ${1+"$@"}
 334
 335# If the branch to rebase is given, that is the branch we will rebase
 336# $branch_name -- branch being rebased, or HEAD (already detached)
 337# $orig_head -- commit object name of tip of the branch before rebasing
 338# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 339switch_to=
 340case "$#" in
 3412)
 342        # Is it "rebase other $branchname" or "rebase other $commit"?
 343        branch_name="$2"
 344        switch_to="$2"
 345
 346        if git show-ref --verify --quiet -- "refs/heads/$2" &&
 347           branch=$(git rev-parse --verify "refs/heads/$2" 2>/dev/null)
 348        then
 349                head_name="refs/heads/$2"
 350        elif branch=$(git rev-parse --verify "$2" 2>/dev/null)
 351        then
 352                head_name="detached HEAD"
 353        else
 354                usage
 355        fi
 356        ;;
 357*)
 358        # Do not need to switch branches, we are already on it.
 359        if branch_name=`git symbolic-ref -q HEAD`
 360        then
 361                head_name=$branch_name
 362                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 363        else
 364                head_name="detached HEAD"
 365                branch_name=HEAD ;# detached
 366        fi
 367        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 368        ;;
 369esac
 370orig_head=$branch
 371
 372# Now we are rebasing commits $upstream..$branch on top of $onto
 373
 374# Check if we are already based on $onto with linear history,
 375# but this should be done only when upstream and onto are the same.
 376mb=$(git merge-base "$onto" "$branch")
 377if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 378        # linear history?
 379        ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
 380then
 381        # Lazily switch to the target branch if needed...
 382        test -z "$switch_to" || git checkout "$switch_to"
 383        echo >&2 "Current branch $branch_name is up to date."
 384        exit 0
 385fi
 386
 387if test -n "$verbose"
 388then
 389        echo "Changes from $mb to $onto:"
 390        # We want color (if set), but no pager
 391        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 392fi
 393
 394# Detach HEAD and reset the tree
 395echo "First, rewinding head to replay your work on top of it..."
 396git checkout -q "$onto^0" || die "could not detach HEAD"
 397git update-ref ORIG_HEAD $branch
 398
 399# If the $onto is a proper descendant of the tip of the branch, then
 400# we just fast forwarded.
 401if test "$mb" = "$branch"
 402then
 403        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 404        move_to_original_branch
 405        exit 0
 406fi
 407
 408if test -z "$do_merge"
 409then
 410        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 411                "$upstream..$orig_head" |
 412        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 413        move_to_original_branch
 414        ret=$?
 415        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 416                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 417                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 418                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head
 419        exit $ret
 420fi
 421
 422# start doing a rebase with git-merge
 423# this is rename-aware if the recursive (default) strategy is used
 424
 425mkdir -p "$dotest"
 426echo "$onto" > "$dotest/onto"
 427echo "$onto_name" > "$dotest/onto_name"
 428prev_head=$orig_head
 429echo "$prev_head" > "$dotest/prev_head"
 430echo "$orig_head" > "$dotest/orig-head"
 431echo "$head_name" > "$dotest/head-name"
 432
 433msgnum=0
 434for cmt in `git rev-list --reverse --no-merges "$upstream..$orig_head"`
 435do
 436        msgnum=$(($msgnum + 1))
 437        echo "$cmt" > "$dotest/cmt.$msgnum"
 438done
 439
 440echo 1 >"$dotest/msgnum"
 441echo $msgnum >"$dotest/end"
 442
 443end=$msgnum
 444msgnum=1
 445
 446while test "$msgnum" -le "$end"
 447do
 448        call_merge "$msgnum"
 449        continue_merge
 450done
 451
 452finish_rb_merge